MODULE module_noahmplsm_dry_dep_ra 
!USE module_sf_noahmplsm

CONTAINS
!Subroutines that calculate RA:  
SUBROUTINE cal_ra(ch,uu,vv,ur,ra) ! Output: ra

    IMPLICIT NONE
    real :: ch                     ! Sensible heat exchange coefficient
    real :: ur                     ! wind speed at height ZLVL (m/s)
    real :: uu,vv                  ! U,V-component of wind (forcing)
    real :: ra

! wind speed at reference height: ur >= 1
    ur = MAX( SQRT(uu**2.+vv**2.), 1. )
    ra=MAX(1.,1./(ch*ur))

END SUBROUTINE cal_ra

END MODULE module_noahmplsm_dry_dep_ra

